package org.processmining.logenhancement.abstraction.editor;

import org.processmining.logenhancement.abstraction.model.AbstractionModel;
import org.processmining.plugins.graphviz.dot.Dot;

import com.kitfox.svg.SVGDiagram;

public final class AbstractionModelAsDot {

	private final AbstractionModel model;
	private final SVGDiagram svg;
	private final Dot dot;

	public AbstractionModelAsDot(AbstractionModel model, Dot dot, SVGDiagram svg) {
		this.model = model;
		this.dot = dot;
		this.svg = svg;
	}

	public Dot getDot() {
		return dot;
	}

	public SVGDiagram getSVG() {
		return svg;
	}

	public AbstractionModel getModel() {
		return model;
	}

}
