package org.processmining.logenhancement.abstraction.model;

import java.util.Collection;
import java.util.Map;

import org.processmining.datapetrinets.DataPetriNetsWithMarkings;
import org.processmining.logenhancement.abstraction.model.syntax.CompositionRoot;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class AbstractionModel {

	private final CompositionRoot composition;

	private final DataPetriNetsWithMarkings combinedDPN;
	private final Map<PetrinetNode, PetrinetNode> old2NewMap;
	private final Collection<AbstractionPattern> patterns;

	public AbstractionModel(CompositionRoot composition, DataPetriNetsWithMarkings combinedDPN,
			Map<PetrinetNode, PetrinetNode> old2NewMap, Collection<AbstractionPattern> patterns) {
		this.composition = composition;
		this.combinedDPN = combinedDPN;
		this.old2NewMap = old2NewMap;
		this.patterns = patterns;
	}

	public DataPetriNetsWithMarkings getCombinedDPN() {
		return combinedDPN;
	}

	public Map<PetrinetNode, PetrinetNode> getOld2NewMap() {
		return old2NewMap;
	}

	public Collection<AbstractionPattern> getPatterns() {
		return patterns;
	}

	public CompositionRoot getComposition() {
		return composition;
	}

}
