package org.processmining.logenhancement.cpn;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import gnu.trove.map.hash.THashMap;

/**
 * @author michael
 * 
 */
class KeyValueImpl implements KeyValue {
	
	private final List<Map<String, Object>> values;

	/**
	 * 
	 */
	@SuppressWarnings("unchecked")
	public KeyValueImpl() {
		this(Collections.EMPTY_LIST);
	}

	/**
	 * @param initial
	 */
	public KeyValueImpl(final Collection<Map<String, Object>> initial) {
		values = new ArrayList<Map<String, Object>>();
		values.addAll(initial);
	}

	/**
	 * @param value
	 */
	@Override
	public void add(final Map<String, Object> value) {
		values.add(new THashMap<String, Object>(value));
	}

	@Override
	public Map<String, Object> get(final int i) {
		return values.get(i);
	}

	/**
	 * @see java.lang.Iterable#iterator()
	 */
	@Override
	public Iterator<Map<String, Object>> iterator() {
		return values.iterator();
	}

	@Override
	public int size() {
		return values.size();
	}
}
