package org.processmining.logenhancement.filtering;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.Progress;
import org.processmining.framework.plugin.annotations.Plugin;

/**
 * Removes all global attribute definitions
 * 
 * @author fmannhardt
 * 
 */
public class ClearEventLogClassifierPlugin {

	private Progress progBar;

	@Plugin(name = "Removes all global attribute definitions from the log", parameterLabels = {
			"Event Log" }, //
			returnLabels = {}, returnTypes = {}, userAccessible = true, mostSignificantResult = -1, 
			help = "Removes the global event and trace attribute XES metadata from the event log.")
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = " F. Mannhardt", email = "f.mannhardt@tue.nl")
	public void removeGlobalAttributes(PluginContext context, XLog log) {

		progBar = context.getProgress();
		progBar.setMinimum(0);
		progBar.setMaximum(1);
		progBar.setValue(0);

		log.getGlobalEventAttributes().clear();
		log.getGlobalTraceAttributes().clear();

		progBar.setValue(1);
	}

}
