package org.processmining.logenhancement.filtering.attributes;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XAttribute;

public class AttributeEditorSelection {

	private AttributeFilterByEnum filterOption;
	private XEventClass eventClass;
	private String attributeName;
	private Object attributeValue;
	private String replacementValue;
	private List<XAttribute> additionalAttributes = new ArrayList<XAttribute>(); 

	public XEventClass getEventClass() {
		return eventClass;
	}

	public void setEventClass(XEventClass eventClass) {
		this.eventClass = eventClass;
	}

	public String getAttributeName() {
		return attributeName;
	}

	public void setAttributeName(String attributeName) {
		this.attributeName = attributeName;
	}

	public Object getAttributeValue() {
		return attributeValue;
	}

	public void setAttributeValue(Object attributeValue) {
		this.attributeValue = attributeValue;
	}

	public AttributeFilterByEnum getFilterOption() {
		return filterOption;
	}

	public void setFilterOption(AttributeFilterByEnum filterOption) {
		this.filterOption = filterOption;
	}

	public String getReplacementValue() {
		return replacementValue;
	}

	public void setReplacementValue(String replacementValue) {
		this.replacementValue = replacementValue;
	}
	
	public String toString() {
		String action;
		if (replacementValue.isEmpty()) {
			action = "Remove";
		} else {
			action = "Replace";
		}
		StringBuilder msg = new StringBuilder(action+" "+attributeName+"'");
		if (attributeValue != null){
			msg.append(" with Value '"+attributeValue+"'");
		}
		if (eventClass != null) {
			msg.append(" for Event Class '"+eventClass+"'");
		}
		if (!replacementValue.isEmpty()) {
			msg.append(" with New Value '"+replacementValue+"'");
		}
		return msg.toString();
	}

	public List<XAttribute> getAdditionalAttributes() {
		return additionalAttributes;
	}
	
}
