package org.processmining.logenhancement.merge.alignmentbased;

import gnu.trove.map.TIntObjectMap;

import org.deckfour.xes.model.XTrace;
import org.processmining.plugins.DataConformance.Alignment;

public interface LogEnhancementResult {
	
	public static final LogEnhancementResult NO_MERGE = new LogEnhancementResult() {
		
		public XTrace getMergedTrace() {
			return null;
		}
		
		public TIntObjectMap<EventEntry> getMergedEvents() {
			return null;
		}
		
		public Alignment getAlignment() {
			return null;
		}

		public XTrace getMasterTrace() {
			return null;
		}
	};
	public static final LogEnhancementResult RETRY = new LogEnhancementResult() {
		
		public XTrace getMergedTrace() {
			return null;
		}
		
		public TIntObjectMap<EventEntry> getMergedEvents() {
			return null;
		}
		
		public XTrace getMasterTrace() {
			return null;
		}
		
		public Alignment getAlignment() {
			return null;
		}
	};
	
	
	Alignment getAlignment();

	XTrace getMasterTrace();
	
	XTrace getMergedTrace();

	TIntObjectMap<EventEntry> getMergedEvents();

}