package org.processmining.logenhancement.sorting;

import java.util.Collections;
import java.util.Comparator;

import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginCategory;

import com.google.common.primitives.Ints;

public final class SortLog {

	@Plugin(name = "Re-sort by length of trace (Shortest First | In Place)", parameterLabels = { "Event Log" }, //
			help = "Sorts the event log by length of trace.", 
			categories = { PluginCategory.Enhancement },
	returnLabels = {}, returnTypes = {}, userAccessible = true, mostSignificantResult = -1)
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = " F. Mannhardt", email = "f.mannhardt@tue.nl")
	public void sortLogShortestFirst(PluginContext context, XLog log) {

		Collections.sort(log, new Comparator<XTrace>() {

			public int compare(XTrace arg0, XTrace arg1) {
				return Ints.compare(arg0.size(), arg1.size());
			}

		});

	}
	
	@Plugin(name = "Re-sort by length of trace (Longest First | In Place)", parameterLabels = { "Event Log" }, //
			help = "Sorts the event log by length of trace.", 
			categories = { PluginCategory.Enhancement },
	returnLabels = {}, returnTypes = {}, userAccessible = true, mostSignificantResult = -1)
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = " F. Mannhardt", email = "f.mannhardt@tue.nl")
	public void sortLogLongestFirst(PluginContext context, XLog log) {

		Collections.sort(log, new Comparator<XTrace>() {

			public int compare(XTrace arg0, XTrace arg1) {
				return Ints.compare(arg1.size(), arg0.size());
			}

		});

	}

}