package org.processmining.logenhancement.utils;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XVisitor;

/**
 * Two {@link XEvent} are equal iff they are the same object instance.
 * 
 * @author F. Mannhardt
 * 
 */
public class XEventIdentityClassifier implements XEventClassifier {

	public String name() {
		return "XEvent Object Identify Classifier";
	}

	public void setName(String name) {
		// 
	}

	public boolean sameEventClass(XEvent eventA, XEvent eventB) {
		return eventA == eventB;
	}

	public String getClassIdentity(XEvent event) {
		return event.getClass().getSimpleName() + "@" + Integer.toHexString(System.identityHashCode(event));
	}

	public String[] getDefiningAttributeKeys() {
		return new String[] {};
	}

	public void accept(XVisitor visitor, XLog log) {
		/*
		 * First call.
		 */
		visitor.visitClassifierPre(this, log);
		/*
		 * Last call.
		 */
		visitor.visitClassifierPost(this, log);
	}

}
