package org.processmining.logenhancement.view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.log.utils.XUtils;

final class ActionDetailExport implements ActionListener {

	private final LogViewContext context;
	private final LogViewDetail detailView;

	ActionDetailExport(LogViewContext context, LogViewDetail detailView) {
		this.context = context;
		this.detailView = detailView;
	}

	public void actionPerformed(ActionEvent e) {
		List<XTrace> selection = detailView.getDetailList().getList().getSelectedValuesList();

		XFactory factory = XFactoryRegistry.instance().currentDefault();
		XLog newLog = factory.createLog();
		XUtils.assignConceptName(newLog, proposeName(selection));
		for (XTrace trace : selection) {
			newLog.add((XTrace) trace.clone());
		}
		
		context.exportLog(newLog);		
	}

	private String proposeName(List<XTrace> selection) {
		if (selection.size() != 1) {
			return "Multiple Traces";
		} else {
			String traceName = XUtils.getConceptName(selection.get(0));
			return "Trace " + traceName != null ? traceName : "";
		}
	}
}